#ifndef __ACM_SURFACE_TEXTURE_SYMBOL_LIBRARY_H
#define __ACM_SURFACE_TEXTURE_SYMBOL_LIBRARY_H
//
//  (C) Copyright 2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//


#include "SymbolLib.h"

//////////////////////////////////////////////////////////////////////////
// class AmdtSurfTextLibObject
class DllImpExp AmdtSurfTextLibObject : public AmdtSymbolLibObject
{
public:
  ACRX_DECLARE_MEMBERS(AmdtSurfTextLibObject);
  AmdtSurfTextLibObject();
  ~AmdtSurfTextLibObject();

  // AcDbObject Interface
  virtual Acad::ErrorStatus dwgInFields (AcDbDwgFiler* pFiler);
  virtual Acad::ErrorStatus dwgOutFields(AcDbDwgFiler* pFiler) const;

  Adesk::Boolean isAllAround() const;
  Adesk::Boolean isForcedTail() const;
  Adesk::Boolean isMajority() const;
  Acm::SurfTextType subType() const;
  bool operator==(const AmdtSurfTextLibObject& surflibObj)const;

protected:
  virtual Acad::ErrorStatus subGetClassID(CLSID* pClsid) const;
};
MAKE_ACDBOPENOBJECT_FUNCTION(AmdtSurfTextLibObject);
DBREF_DECLARE(AmdtSurfTextLibObject)


////////////////////////////////////////////////////////////////
// class AmdtSurfTextLibrary
class DllImpExp AmdtSurfTextLibrary : public AmdtSymbolLibrary
{
public:
  ACRX_DECLARE_MEMBERS(AmdtSurfTextLibrary);
  AmdtSurfTextLibrary();

  virtual const ACHAR *name() const;

  // Retrieve stored item
  virtual Acad::ErrorStatus loadItem(const ACHAR *itemName, AcmSymbol *pSym);

  // Add new item
  virtual Acad::ErrorStatus appendItem(const ACHAR *itemName, AcmSymbol *pSym, AcDbObjectId& id, bool bCheckValidName=true);
  virtual Acad::ErrorStatus appendItem(AmdtSymbolLibObject* pObj, AcDbObjectId& id, bool bCheckValidName=true);

  // Update existing item
  virtual Acad::ErrorStatus modifyItem(const ACHAR *itemName, AcmSymbol *pSym);

protected:
  // AcDbObject Interface
  virtual Acad::ErrorStatus subGetClassID(CLSID* pClsid) const;
};
MAKE_ACDBOPENOBJECT_FUNCTION(AmdtSurfTextLibrary);
DBREF_DECLARE(AmdtSurfTextLibrary)

//////////////////////////////////////////////////////////////////////////
// Global function
DllImpExp bool getAcmSurfaceTextureLibrary(AcDbObjectId &libId, AcDbDatabase *pDb=NULL, bool bCreateIfNotExist=true);


#endif //